/*
* Licensed to the Apache Software Foundation (ASF) under one or more
* contributor license agreements.  See the NOTICE file distributed with
* this work for additional information regarding copyright ownership.
* The ASF licenses this file to You under the Apache License, Version 2.0
* (the "License"); you may not use this file except in compliance with
* the License.  You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

    package com.ywt.gapi.medicalrecord;

import org.apache.dubbo.common.stream.StreamObserver;
import com.google.protobuf.Message;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.concurrent.CompletableFuture;

public interface MedicalRecordService extends org.apache.dubbo.rpc.model.DubboStub {

    String JAVA_SERVICE_NAME = "com.ywt.gapi.medicalrecord.MedicalRecordService";
    String SERVICE_NAME = "com.ywt.gapi.medicalrecord.MedicalRecordService";

        /**
         * <pre>
         * 检查报告单id
         * </pre>
         */
    com.ywt.gapi.medicalrecord.GetMedicalRecordByIdResponse getMedicalRecordById(com.ywt.gapi.medicalrecord.GetMedicalRecordByIdRequest request);

    default CompletableFuture<com.ywt.gapi.medicalrecord.GetMedicalRecordByIdResponse> getMedicalRecordByIdAsync(com.ywt.gapi.medicalrecord.GetMedicalRecordByIdRequest request){
        return CompletableFuture.completedFuture(getMedicalRecordById(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getMedicalRecordById(com.ywt.gapi.medicalrecord.GetMedicalRecordByIdRequest request, StreamObserver<com.ywt.gapi.medicalrecord.GetMedicalRecordByIdResponse> responseObserver){
        getMedicalRecordByIdAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 检查报告单标题名称
         * </pre>
         */
    com.ywt.gapi.medicalrecord.GetOutpatientRecordListResponse getOutpatientRecordList(com.ywt.gapi.medicalrecord.GetOutpatientRecordListRequest request);

    default CompletableFuture<com.ywt.gapi.medicalrecord.GetOutpatientRecordListResponse> getOutpatientRecordListAsync(com.ywt.gapi.medicalrecord.GetOutpatientRecordListRequest request){
        return CompletableFuture.completedFuture(getOutpatientRecordList(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getOutpatientRecordList(com.ywt.gapi.medicalrecord.GetOutpatientRecordListRequest request, StreamObserver<com.ywt.gapi.medicalrecord.GetOutpatientRecordListResponse> responseObserver){
        getOutpatientRecordListAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 检查报告单审核日期（YYYY-MM-DD HH:MM:SS）
         * </pre>
         */
    com.ywt.gapi.Result syncReport(com.ywt.gapi.medicalrecord.SyncReportRequest request);

    default CompletableFuture<com.ywt.gapi.Result> syncReportAsync(com.ywt.gapi.medicalrecord.SyncReportRequest request){
        return CompletableFuture.completedFuture(syncReport(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void syncReport(com.ywt.gapi.medicalrecord.SyncReportRequest request, StreamObserver<com.ywt.gapi.Result> responseObserver){
        syncReportAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 报告状态 0 未审核 1已审核
         * </pre>
         */
    com.ywt.gapi.medicalrecord.GetOutpatientRecordListByHisPatientIdResponse getOutpatientRecordListByHisPatientId(com.ywt.gapi.medicalrecord.GetOutpatientRecordListByHisPatientIdRequest request);

    default CompletableFuture<com.ywt.gapi.medicalrecord.GetOutpatientRecordListByHisPatientIdResponse> getOutpatientRecordListByHisPatientIdAsync(com.ywt.gapi.medicalrecord.GetOutpatientRecordListByHisPatientIdRequest request){
        return CompletableFuture.completedFuture(getOutpatientRecordListByHisPatientId(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void getOutpatientRecordListByHisPatientId(com.ywt.gapi.medicalrecord.GetOutpatientRecordListByHisPatientIdRequest request, StreamObserver<com.ywt.gapi.medicalrecord.GetOutpatientRecordListByHisPatientIdResponse> responseObserver){
        getOutpatientRecordListByHisPatientIdAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

        /**
         * <pre>
         * 患者姓名
         * </pre>
         */
    com.ywt.gapi.medicalrecord.DeleteMedicalRecordTemplateResponse deleteMedicalRecordTemplate(com.ywt.gapi.medicalrecord.DeleteMedicalRecordTemplateRequest request);

    default CompletableFuture<com.ywt.gapi.medicalrecord.DeleteMedicalRecordTemplateResponse> deleteMedicalRecordTemplateAsync(com.ywt.gapi.medicalrecord.DeleteMedicalRecordTemplateRequest request){
        return CompletableFuture.completedFuture(deleteMedicalRecordTemplate(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void deleteMedicalRecordTemplate(com.ywt.gapi.medicalrecord.DeleteMedicalRecordTemplateRequest request, StreamObserver<com.ywt.gapi.medicalrecord.DeleteMedicalRecordTemplateResponse> responseObserver){
        deleteMedicalRecordTemplateAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }






}
